/*
 * $Id: config.h,v 1.16 1998/06/03 21:40:34 masaki Exp $
 */

#ifndef _CONFIG_MRTD_H
#define _CONFIG_MRTD_H

#include <mrt.h>

typedef struct _config_mrtd_t {
    int line;			/* when parsing file, current lineno */
/* I'm not sure the following are used */
    int sockfd;			/* socket if being configured by user */
    /* int state; */		/* router, interface, etc */
    int instance;		/* protocol, or interface number */
    int negate;			/* command prefeced by a "no" */
    char *password;		/* non-encrypted password */
    route_map_t *route_map;
    interface_t *interface;	/* umm, not interface number ... */
    LINKED_LIST *ll_interfaces;
    LINKED_LIST *ll_static_routes;
    time_t dump_route_time;
    time_t dump_route_last;
    char *dump_route_form;
    time_t dump_update_time;
    time_t dump_update_last;
    char *dump_update_form;
    int protocol;
} config_mrtd_t;

typedef struct _static_route_t {
    prefix_t *prefix;
    prefix_t *nexthop;
    interface_t *interface;
    int pref;
} static_route_t;

extern config_mrtd_t *CONFIG_MRTD;       /* from config.c */
extern int BGPSIM;
extern int running;

#ifdef notdef
int config_ip_route (uii_connection_t * uii, prefix_t *prefix, 
		     prefix_t *nexthop, int num_optional, int pref);
int no_config_ip_route (uii_connection_t * uii, prefix_t *prefix);
int config_distribute_list (uii_connection_t * uii,
                        int num, char *in_or_out, int opt_num, char *name);
#ifdef HAVE_IPV6
int config_interface (uii_connection_t * uii);
int config_gateway (uii_connection_t * uii);
int config_router_ripng (uii_connection_t * uii);
#endif /* HAVE_IPV6 */
int config_router_rip (uii_connection_t * uii);
int config_router_bgp (uii_connection_t *uii, u_int as, int num_opt, 
		       char *rest);
int config_router_network_prefix (uii_connection_t * uii, prefix_t *prefix);
int config_router_network_name (uii_connection_t * uii, char *name);
int config_router_aggregate (uii_connection_t *uii, prefix_t *prefix, 
			     char *rest);
int config_redistribute (uii_connection_t * uii, char *proto);
int config_debug (uii_connection_t * uii);
int config_dump_bgp_updates (uii_connection_t *uii, char *file, char *unit);
int config_dump_bgp_routes (uii_connection_t *uii, char *filename, char *unit);
#endif

void check_passwd ();
int show_rib_routes ();
int show_rib_status ();
int show_rip_routing_table ();
int show_bgp_routing_table ();
#ifdef HAVE_IPV6
void show_ripng ();
int show_ripng_routing_table ();
#endif /* HAVE_IPV6 */

int show_threads ();
int show_view ();
int process_bgp_update ();
int show_bgp ();

int init_mrtd_config (trace_t * trace);
void config_create_default ();

int rip_debug (uii_connection_t * uii);
int bgp_debug (uii_connection_t * uii);
#ifdef notdef
#ifdef HAVE_IPV6
int ripng_debug (uii_connection_t * uii);
#endif /* HAVE_IPV6 */
#endif

#endif /* _CONFIG_MRTD_H */

